package com.engine.kq.bean;

import weaver.cache.*;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.hrm.job.JobActivitiesComInfo;
import weaver.hrm.job.JobGroupsComInfo;
import weaver.hrm.job.JobTitlesComInfo;
import weaver.hrm.resource.ResourceComInfo;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * @Auther: Administrator
 * @Date: 2019-03-08 16:23
 * @Description:
 */
public class KQLeaveRulesDetail extends BaseBean {

    /**
     * 假期规则的ID
     */

    private int id;

    /**
     * 假期类型的ID
     */

    private String ruleId;

    /**
     * 假期规则名称
     */

    private String ruleName;

    /**
     * 应用范围：0-总部、1-分部
     */

    private String scopeType;

    /**
     * 分部ID(当应用范围为分部时选择的分部ID)
     */

    private String scopeValue;

    /**
     * 余额发放方式：
     * 1-手动发放
     * 2-按司龄自动发放
     * 3-按工龄自动发放
     * 4-每年自动发放固定天数
     * 5-加班时长自动计入余额
     * 6-按司龄+工龄自动发放
     */
    private String distributionMode;

    /**
     * 每人发放小时（天）数
     * 注：当余额发放方式为"4-每年自动发放固定天数"时有效
     */

    private String annualAmount;

    /**
     * 法定年假的规则：(当【余额发放方式】选择【6-按司龄+工龄自动发放】才有效)
     * 0-工龄(默认)
     * 1-司龄
     * 2-司龄+工龄
     */

    private String legalKey;

    /**
     * 福利年假的规则：(当【余额发放方式】选择【6-按司龄+工龄自动发放】才有效)
     * 0-工龄
     * 1-司龄(默认)
     * 2-司龄+工龄
     */

    private String welfareKey;

    /**
     * 扣减优先级：(当【余额发放方式】选择【6-按司龄+工龄自动发放】才有效)
     * 1-法定年假
     * 2-福利年假
     */

    private String priority;

    /**
     * 计算方式
     */

    private String calcMethod;

    /**
     * //假期基数的发放日期
     * //1--每年的1月1号
     * //2--入职日期
     * //3--参加工作日期
     */

    private String baseAmountReleaseDate;

    /**
     * //假期基数的变动日期
     * //1--每年的1月1号
     * //2--入职日期
     * //3--参加工作日期
     */

    private String baseAmountChangeDate;

    /**
     * 假期基数折算方式
     * 0--不折算
     * 1--四舍五入
     * 2--向上取整
     * 3--向下取整
     * 4--向上取0.5的倍数
     * 5--向下取0.5的倍数
     */

    private String convertMode;

    /**
     * 折算后保留的小数点位数
     */

    private String decimalDigit;

    /**
     * 有效期规则
     * 0-永久有效
     * 1-按自然年(1月1日-12月31日)
     * 2-按入职日期起12个月
     * 3-自定义次年失效日期
     * 4-按天数失效
     * 5-按季度失效
     * 6-按月数失效
     */

    private String validityRule;

    /**
     * 失效日期-月
     */

    private String expirationMonth;

    /**
     * 失效日期-日
     */

    private String expirationDay;

    /**
     * 有效天数
     */

    private String effectiveDays;

    /**
     * 有效月数
     */

    private String effectiveMonths;

    /**
     * 是否允许延长有效期
     * 0-不允许
     * 1-允许
     */

    private String extensionEnable;

    /**
     * 允许延长的有效期天数
     */

    private String extendedDays;

    /**
     * 释放规则
     * 0-不限制
     * 1-按天释放
     * 2-按月释放
     */

    private String releaseRule;

    /**
     * 假期类型
     */

    private String leaveCode;

    /**
     * 是否需要排除次账号
     * 0--不排除，即次账号正常享受年假
     * 1--排除，即次账号不能享受年假
     */

    private String excludeSubAccount;

    /**
     * 转正之前是否允许发放假期余额
     * 0--不允许
     * 1--允许
     */

    private String beforeFormal;


    public KQLeaveRulesDetail initCache(String key) {
        if (key == null || "".equals(key.trim())) {
            return null;
        }
        KQLeaveRulesDetail kqLeaveRulesDetail = new KQLeaveRulesDetail();
        RecordSet rs = new RecordSet();
        String sql = "select * from kq_leaveRulesDetail where (isDelete is null or isDelete<>1) and id=" + key;
        rs.executeQuery(sql);
        if (rs.next()) {

//            String _ruleId = rs.getString("ruleId");//假期类型的ID
//            String _ruleName = rs.getString("ruleName");//假期类型的ID
//            String _scopeType = rs.getString("scopeType");//假期类型的流程可见范围
//            String _scopeValue = rs.getString("scopeValue");//流程可见范围为分部时勾选的分部ID
//            String _distributionMode = rs.getString("distributionMode");
//            String _annualAmount = rs.getString("annualAmount");
//            String _legalKey = rs.getString("legalKey");
//            String _welfareKey = rs.getString("welfareKey");
//            String _priority = rs.getString("priority");
//            String _calcMethod = rs.getString("calcMethod");
//            String _baseAmountReleaseDate = rs.getString("baseAmountReleaseDate");
//            String _baseAmountChangeDate = rs.getString("baseAmountChangeDate");
//            String _convertMode = rs.getString("convertMode");
//            String _decimalDigit = rs.getString("decimalDigit");
//            String _validityRule = rs.getString("validityRule");
//            String _expirationMonth = rs.getString("expirationMonth");
//            String _expirationDay = rs.getString("expirationDay");
//            String _effectiveDays = rs.getString("effectiveDays");
//            String _effectiveMonths = rs.getString("effectiveMonths");
//            String _extensionEnable = rs.getString("extensionEnable");
//            String _extendedDays = rs.getString("extendedDays");
//            String _releaseRule = rs.getString("releaseRule");
//            String _leaveCode = rs.getString("leaveCode");
//            String _excludeSubAccount = rs.getString("excludeSubAccount");
//            String _beforeFormal = rs.getString("beforeFormal");

            kqLeaveRulesDetail.setId(rs.getInt("id"));
            kqLeaveRulesDetail.setRuleId(rs.getString("ruleId"));
            kqLeaveRulesDetail.setDistributionMode(rs.getString("distributionMode"));
            kqLeaveRulesDetail.setAnnualAmount(rs.getString("annualAmount"));
            kqLeaveRulesDetail.setLegalKey(rs.getString("legalKey"));
            kqLeaveRulesDetail.setWelfareKey(rs.getString("welfareKey"));
            kqLeaveRulesDetail.setPriority(rs.getString("priority"));
            kqLeaveRulesDetail.setCalcMethod(rs.getString("calcMethod"));
            kqLeaveRulesDetail.setBaseAmountReleaseDate(rs.getString("baseAmountReleaseDate"));
            kqLeaveRulesDetail.setBaseAmountChangeDate(rs.getString("baseAmountChangeDate"));
            kqLeaveRulesDetail.setConvertMode(rs.getString("convertMode"));
            kqLeaveRulesDetail.setDecimalDigit("2");
            kqLeaveRulesDetail.setValidityRule(rs.getString("validityRule"));
            kqLeaveRulesDetail.setExpirationMonth(rs.getString("expirationMonth"));
            kqLeaveRulesDetail.setExpirationDay(rs.getString("expirationDay"));
            kqLeaveRulesDetail.setEffectiveDays(rs.getString("effectiveDays"));
            kqLeaveRulesDetail.setEffectiveMonths(rs.getString("effectiveMonths"));
            kqLeaveRulesDetail.setExtensionEnable(rs.getString("extensionEnable"));
            kqLeaveRulesDetail.setExtendedDays(rs.getString("extendedDays"));
            kqLeaveRulesDetail.setReleaseRule(rs.getString("releaseRule"));
            kqLeaveRulesDetail.setExcludeSubAccount(rs.getString("excludeSubAccount"));
            kqLeaveRulesDetail.setBeforeFormal(rs.getString("beforeFormal"));
        } else {
            rs.writeLog("kqbalanceofleavebiz.key=" + key + ",ruleId=,没有所属的假期规则。");
        }
        return kqLeaveRulesDetail;
    }


    public String getKqLeaveRulesId(String key, int resseclevel, String leaveId) {
        String ruleId = "0";
        RecordSet rs = new RecordSet();
        List<Integer> ids = new ArrayList<>();
        try {
            ResourceComInfo resourceComInfo = new ResourceComInfo();
            JobTitlesComInfo jobTitlesComInfo =new JobTitlesComInfo();
            JobActivitiesComInfo jobActivitiesComInfo = new JobActivitiesComInfo();
            JobGroupsComInfo jobGroupsComInfo = new JobGroupsComInfo();

            String subcompanyid = Util.null2String(resourceComInfo.getSubCompanyID(key));//分部
            String departmentid = Util.null2String(resourceComInfo.getDepartmentID(key));//部门
            String jobtitle = Util.null2String(resourceComInfo.getJobTitle(key));//岗位

            String jobgroupid = jobActivitiesComInfo.getJobgroupid(jobTitlesComInfo.getJobactivityid(jobtitle));//职务类型id
//            jobGroupsComInfo.getJobGroupsname(jobActivitiesComInfo.getJobgroupid(jobTitlesComInfo.getJobactivityid(Util.null2String(rs.getString("jobtitle")))));

            String tmpsql = "select * from kq_leaveRulesDetail where 1=1 and (isDelete is null or isDelete !=1) ";
            //所有人
            String sql = tmpsql + " and ruleid='" + leaveId + "' and scopeType='0' ";
            rs.executeQuery(sql);
            while (rs.next()) {
                int seclevel = Util.getIntValue(rs.getString("seclevel"), 0);
                int seclevelto = Util.getIntValue(rs.getString("seclevelto"), 100);
//                if (resseclevel >= seclevel && resseclevel <= seclevelto) {
                ids.add(rs.getInt("id"));
//                }
            }

            //分部
            sql = tmpsql + " and ruleid='" + leaveId + "' and (scopeType='1' and concat(',',scopeValue,',') like '%," + subcompanyid + ",%') ";
            rs.executeQuery(sql);
            while (rs.next()) {
                int seclevel = Util.getIntValue(rs.getString("seclevel"), 0);
                int seclevelto = Util.getIntValue(rs.getString("seclevelto"), 100);
//                if (resseclevel >= seclevel && resseclevel <= seclevelto) {
                ids.add(rs.getInt("id"));
//                }
            }

            //职务类型
            sql = tmpsql + " and ruleid='" + leaveId + "' and (scopeType='5' and concat(',',scopeValue,',') like '%," + jobgroupid + ",%') ";
            rs.executeQuery(sql);
            while (rs.next()) {
                ids.add(rs.getInt("id"));
            }

//            //人员
//            sql = tmpsql + " and ruleid='" + leaveId + "' and (scopeType='3' and concat(',',scopeValue,',') like '%," + key + ",%') ";
//            rs.executeQuery(sql);
//            while (rs.next()) {
//                ids.add(rs.getInt("id"));
//            }
//
//            //部门
//            sql = tmpsql + " and ruleid='" + leaveId + "' and (scopeType='2' and concat(',',scopeValue,',') like '%," + departmentid + ",%') ";
//            rs.executeQuery(sql);
//            while (rs.next()) {
//                ids.add(rs.getInt("id"));
//            }

            //岗位
//            sql = tmpsql + " and ruleid='" + leaveId + "' and (scopeType='4' and concat(',',scopeValue,',') like '%," + jobtitle + ",%') ";
//            rs.executeQuery(sql);
//            while (rs.next()) {
//                ids.add(rs.getInt("id"));
//            }


            if (ids.size() > 0) {
                ruleId = Util.null2String(Collections.max(ids));
            }


        } catch (Exception e) {

        }
        return ruleId;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getRuleId() {
        return ruleId;
    }

    public void setRuleId(String ruleId) {
        this.ruleId = ruleId;
    }

    public String getRuleName() {
        return ruleName;
    }

    public void setRuleName(String ruleName) {
        this.ruleName = ruleName;
    }

    public String getScopeType() {
        return scopeType;
    }

    public void setScopeType(String scopeType) {
        this.scopeType = scopeType;
    }

    public String getScopeValue() {
        return scopeValue;
    }

    public void setScopeValue(String scopeValue) {
        this.scopeValue = scopeValue;
    }

    public String getDistributionMode() {
        return distributionMode;
    }

    public void setDistributionMode(String distributionMode) {
        this.distributionMode = distributionMode;
    }

    public String getAnnualAmount() {
        return annualAmount;
    }

    public void setAnnualAmount(String annualAmount) {
        this.annualAmount = annualAmount;
    }

    public String getLegalKey() {
        return legalKey;
    }

    public void setLegalKey(String legalKey) {
        this.legalKey = legalKey;
    }

    public String getWelfareKey() {
        return welfareKey;
    }

    public void setWelfareKey(String welfareKey) {
        this.welfareKey = welfareKey;
    }

    public String getPriority() {
        return priority;
    }

    public void setPriority(String priority) {
        this.priority = priority;
    }

    public String getCalcMethod() {
        return calcMethod;
    }

    public void setCalcMethod(String calcMethod) {
        this.calcMethod = calcMethod;
    }

    public String getBaseAmountReleaseDate() {
        return baseAmountReleaseDate;
    }

    public void setBaseAmountReleaseDate(String baseAmountReleaseDate) {
        this.baseAmountReleaseDate = baseAmountReleaseDate;
    }

    public String getBaseAmountChangeDate() {
        return baseAmountChangeDate;
    }

    public void setBaseAmountChangeDate(String baseAmountChangeDate) {
        this.baseAmountChangeDate = baseAmountChangeDate;
    }

    public String getConvertMode() {
        return convertMode;
    }

    public void setConvertMode(String convertMode) {
        this.convertMode = convertMode;
    }

    public String getDecimalDigit() {
        return decimalDigit;
    }

    public void setDecimalDigit(String decimalDigit) {
        this.decimalDigit = decimalDigit;
    }

    public String getValidityRule() {
        return validityRule;
    }

    public void setValidityRule(String validityRule) {
        this.validityRule = validityRule;
    }

    public String getExpirationMonth() {
        return expirationMonth;
    }

    public void setExpirationMonth(String expirationMonth) {
        this.expirationMonth = expirationMonth;
    }

    public String getExpirationDay() {
        return expirationDay;
    }

    public void setExpirationDay(String expirationDay) {
        this.expirationDay = expirationDay;
    }

    public String getEffectiveDays() {
        return effectiveDays;
    }

    public void setEffectiveDays(String effectiveDays) {
        this.effectiveDays = effectiveDays;
    }

    public String getEffectiveMonths() {
        return effectiveMonths;
    }

    public void setEffectiveMonths(String effectiveMonths) {
        this.effectiveMonths = effectiveMonths;
    }

    public String getExtensionEnable() {
        return extensionEnable;
    }

    public void setExtensionEnable(String extensionEnable) {
        this.extensionEnable = extensionEnable;
    }

    public String getExtendedDays() {
        return extendedDays;
    }

    public void setExtendedDays(String extendedDays) {
        this.extendedDays = extendedDays;
    }

    public String getReleaseRule() {
        return releaseRule;
    }

    public void setReleaseRule(String releaseRule) {
        this.releaseRule = releaseRule;
    }

    public String getLeaveCode() {
        return leaveCode;
    }

    public void setLeaveCode(String leaveCode) {
        this.leaveCode = leaveCode;
    }

    public String getExcludeSubAccount() {
        return excludeSubAccount;
    }

    public void setExcludeSubAccount(String excludeSubAccount) {
        this.excludeSubAccount = excludeSubAccount;
    }

    public String getBeforeFormal() {
        return beforeFormal;
    }

    public void setBeforeFormal(String beforeFormal) {
        this.beforeFormal = beforeFormal;
    }
}
